<?php

namespace DL6\WTC\Widget;

use XF\Widget\AbstractWidget;

class TagCloud extends AbstractWidget
{
	protected $defaultOptions = [
		'limit' => 50,
		'minUses' => '1',
	];

	public function render()
	{
		$options = $this->options;
		$limit = $options['limit'];
		$minUses = $options['minUses'];		


		$tagRepo = $this->repository('XF:Tag');

		$cloudEntries = $tagRepo->getTagsForCloud($limit, $minUses);
        $tagCloud = $tagRepo->getTagCloud($cloudEntries);
        $title = \XF::phrase('popular_tags');

		$viewParams = [
			'title' => $this->getTitle() ?: $title,
			'tagCloud' => $tagCloud
		];
		return $this->renderer('dl6_wtc_widget_tag_cloud', $viewParams);
	}

	public function verifyOptions(\XF\Http\Request $request, array &$options, &$error = null)
	{
		$options = $request->filter([
			'limit' => 'uint',
			'minUses' => 'uint'
        ]);
        if ($options['limit'] < 10)
		{
			$options['limit'] = 10;
		}
		if ($options['minUses'] < 1)
		{
			$options['minUses'] = 1;
		}
		
		return true;
	}
}